// RollingDigit.cpp : implementation file
//

#include "stdafx.h"
#include "CoolClock.h"
#include "RollingClk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//#define NORMAL_TEXT_HEIGHT 15


//for timing event
#define IDE_INTERVAL 0
#define IDE_SPEED 1

//for carry
#define CA_FIVE 5
#define CA_NINE 9
/////////////////////////////////////////////////////////////////////////////
// CRollingClk
char* pDigit[10] = {"0","1","2","3",
					"4","5","6",
					"7","8","9"};


CRollingClk::CRollingClk()
{
}

CRollingClk::~CRollingClk()
{
	m_bFirstTime = TRUE;
	m_Clip = 0;

}


BEGIN_MESSAGE_MAP(CRollingClk, CStatic)
	//{{AFX_MSG_MAP(CRollingClk)
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRollingClk message handlers

void CRollingClk::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	//Create the font
	
	//select the font
	CFont ArialFont;
	BOOL bSuccess = ArialFont.CreateFont(m_SrollingRect.Height(), 0, 0, 0, 
   								FW_THIN, 0,0, 0, 
   								ANSI_CHARSET,
                               	OUT_DEFAULT_PRECIS,
                               	CLIP_DEFAULT_PRECIS,
                               	PROOF_QUALITY,
                               	VARIABLE_PITCH | 0x04 | FF_DONTCARE,
                               	(LPSTR)"Arial");

	CFont*pOldFont = dc.SelectObject(&ArialFont);

	//select the Background
	CBrush bkBrush(m_BkColor);
	CBrush* pOldBrush;
	pOldBrush = dc.SelectObject(&bkBrush);


	//set the text color and mode
	dc.SetTextColor(m_DigitColor);
	dc.SetBkMode(TRANSPARENT);
	
	if(m_bFirstTime){

	
		m_TimeArray[0]=m_CurrentTime.GetHour()/10;

		m_TimeArray[1]=m_CurrentTime.GetHour()%10;

 		m_TimeArray[2]=m_CurrentTime.GetMinute()/10;

		m_TimeArray[3]=m_CurrentTime.GetMinute()%10;

		m_TimeArray[4]=m_CurrentTime.GetSecond()/10;
		m_TimeArray[5]=m_CurrentTime.GetSecond()%10;
		



		dc.FillRect(&m_SrollingRect,&bkBrush);
		

		//seperator
		dc.DrawText((const char*)_T(":"),1,&m_rcCell[2],DT_VCENTER|DT_CENTER|
		DT_NOPREFIX|DT_SINGLELINE);

		dc.DrawText((const char*)_T(":"),1,&m_rcCell[5],DT_VCENTER|DT_CENTER|
		DT_NOPREFIX|DT_SINGLELINE);

		//display the time

		//hours
		dc.DrawText((const char*)pDigit[m_TimeArray[0]],1,&m_rcCell[0],DT_VCENTER|DT_CENTER|
		DT_NOPREFIX|DT_SINGLELINE);

		dc.DrawText((const char*)pDigit[m_TimeArray[1]],1,&m_rcCell[1],DT_VCENTER|DT_CENTER|
		DT_NOPREFIX|DT_SINGLELINE);

		//minutes
		dc.DrawText((const char*)pDigit[m_TimeArray[2]],1,&m_rcCell[3],DT_VCENTER|DT_CENTER|
		DT_NOPREFIX|DT_SINGLELINE);

		dc.DrawText((const char*)pDigit[m_TimeArray[3]],1,&m_rcCell[4],DT_VCENTER|DT_CENTER|
		DT_NOPREFIX|DT_SINGLELINE);

		//seconds
		dc.DrawText((const char*)pDigit[m_TimeArray[4]],1,&m_rcCell[6],DT_VCENTER|DT_CENTER|
		DT_NOPREFIX|DT_SINGLELINE);

		dc.DrawText((const char*)pDigit[m_TimeArray[5]],1,&m_rcCell[7],DT_VCENTER|DT_CENTER|
		DT_NOPREFIX|DT_SINGLELINE);
		
		
		m_bFirstTime = FALSE;		

		return;

	}



	//parse the current time
	m_TimeArray[0]=m_CurrentTime.GetHour()/10;

	m_TimeArray[1]=m_CurrentTime.GetHour()%10;

	m_TimeArray[2]=m_CurrentTime.GetMinute()/10;

	m_TimeArray[3]=m_CurrentTime.GetMinute()%10;

	m_TimeArray[4]=m_CurrentTime.GetSecond()/10;
	m_TimeArray[5]=m_CurrentTime.GetSecond()%10;


	/*
	
	    The following farts could have been wirten with recursion.However,it would 
		take some more into consideration.and beside,its layers are not that deep.Those 
		who have interest can do do the alternation as they wish.

	*/

	 if(m_TimeArray[5]==CA_NINE){				

		if(m_TimeArray[4]==CA_FIVE){
			if(m_TimeArray[3] == CA_NINE){
				if(m_TimeArray[2] == CA_FIVE){
					if(m_TimeArray[1] == 3 && m_TimeArray[0]==2){
						if(m_TimeArray[0] == 2){
							RollingText(dc,m_rcCell[0],pDigit[m_TimeArray[0]],pDigit[0],bkBrush);
						}
						else{
							RollingText(dc,m_rcCell[0],pDigit[m_TimeArray[0]],pDigit[m_TimeArray[0]+1],bkBrush);
						}		//end of the Hour/10	

						RollingText(dc,m_rcCell[1],pDigit[m_TimeArray[1]],pDigit[0],bkBrush);
					}
					else {
						RollingText(dc,m_rcCell[1],pDigit[m_TimeArray[1]],pDigit[m_TimeArray[1]+1],bkBrush);
					}//end of the Hour%10

					RollingText(dc,m_rcCell[3],pDigit[m_TimeArray[2]],pDigit[0],bkBrush);
				}
				else {
					RollingText(dc,m_rcCell[3],pDigit[m_TimeArray[2]],pDigit[m_TimeArray[2]+1],bkBrush);
				}// end of min/10

				RollingText(dc,m_rcCell[4],pDigit[m_TimeArray[3]],pDigit[0],bkBrush);
			}

			else {
				RollingText(dc,m_rcCell[4],pDigit[m_TimeArray[3]],pDigit[m_TimeArray[3]+1],bkBrush);
				
			}//end of min%10
	
			RollingText(dc,m_rcCell[6],pDigit[m_TimeArray[4]],pDigit[0],bkBrush);

		}

		else {
			RollingText(dc,m_rcCell[6],pDigit[m_TimeArray[4]],pDigit[m_TimeArray[4]+1],bkBrush);
		}// end of sec%10

		RollingText(dc,m_rcCell[7],pDigit[m_TimeArray[5]],pDigit[0],bkBrush);			
	}
		
	else{	

		RollingText(dc,m_rcCell[7],pDigit[m_TimeArray[5]],pDigit[m_TimeArray[5]+1],bkBrush);
	} //end of sec/10

		
	//kill the rolling timer
	if(m_Clip == m_SrollingRect.Height()){

		m_Clip = 0;
		KillTimer(IDE_SPEED);

	}
			
	//Clear
	dc.SelectObject(pOldFont);
	dc.SelectObject(pOldFont);

	ArialFont.DeleteObject();
	bkBrush.DeleteObject();

	// Do not call CStatic::OnPaint() for painting messages
}


void CRollingClk::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	switch(nIDEvent){

	case IDE_SPEED:{
		m_Clip++;
		InvalidateRect(&m_SrollingRect,FALSE);
		break;
				   }

	case IDE_INTERVAL:{

		m_CurrentTime = m_CurrentTime.GetCurrentTime();
		SetTimer(IDE_SPEED,m_nElapse,NULL);
		break;

					}
	default:
		break;

	}



	CStatic::OnTimer(nIDEvent);
}

BOOL CRollingClk::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	return TRUE;
//	return CStatic::OnEraseBkgnd(pDC);
}

void CRollingClk::Start(COLORREF bkColor ,COLORREF DigitColor ,UINT nSpeed)
{

	//initialization
	m_BkColor = bkColor;
	m_DigitColor = DigitColor;

	m_nElapse = nSpeed;
	GetClientRect(&m_SrollingRect);
	int Unit_Len = (int)m_SrollingRect.Width()/8;

	for(int i=0;i<8;i++){
		m_rcCell[i] = m_SrollingRect;
		m_rcCell[i].left = m_SrollingRect.left + i*Unit_Len;
		m_rcCell[i].right = m_SrollingRect.left + (i+1)*Unit_Len;
	}

	for(i=0;i<6;i++){
		m_TimeArray[i] = 0;
	}


	m_CurrentTime = m_CurrentTime.GetCurrentTime();

	m_bFirstTime = TRUE;
	m_Clip = 0;

	//set 2 timers, the first is interrupted after 1 sec,
	// the second one  is interrupted after nSpeed msec

	SetTimer(IDE_INTERVAL,1000,NULL);
	SetTimer(IDE_SPEED,nSpeed,NULL);
	
}



void CRollingClk::RollingText(CPaintDC &dc,RECT rc, CString Text,CString nexText,CBrush &bkBrush)
{
		RECT rc1,rc2;

		rc1 = rc;
		rc2 = rc;
	
		rc1.bottom = rc1.bottom - m_Clip;
		rc2.top = rc2.bottom - m_Clip;

	
		dc.FillRect(&rc1,&bkBrush);
		dc.FillRect(&rc2,&bkBrush);

		dc.DrawText((const char*)Text,Text.GetLength(),&rc1,DT_BOTTOM|DT_CENTER|
		DT_NOPREFIX|DT_SINGLELINE);

		dc.DrawText((const char*)nexText,nexText.GetLength(),&rc2,DT_TOP|DT_CENTER|
		DT_NOPREFIX|DT_SINGLELINE);


}


BOOL CRollingClk::IsFirstTime()
{
	return m_bFirstTime;
}

void CRollingClk::SetFirstTime(BOOL bFirstTime)
{
	m_bFirstTime = bFirstTime;
}
